//-----------------------------------------------------------
//
//	Softbolts Ltd. (c) all rights reserved
//
//	Warning: This  program is  protected by copyright law 
//		 and   international  treaties.  Unauthorised
//		 reproduction or distribution of this program,
//		 or  any portion  or it, may result in severe
//		 civil  and  criminal  penalties, and will be
//		 prosecuted to  the  maximum extent possible.
//
//              Author: A. E. Dawson, Aug 1999
//              mailto: anthony@softbolts.com
//
//		Last Revised: 14 Oct 2002
//
//-----------------------------------------------------------

package com.softbolts.connectors.TBDB;

import com.softbolts.lib.*;

import java.io.*;
import java.net.*;
import java.util.*;
import java.lang.Throwable;
import java.sql.*;

//-----------------------------------------------------------
public class DBConnection extends Thread
{
 private Connection conn;
 PollerState connPollerState = null;
 String connectionStr = null;
 String login = null;
 String passwd = null;

	//-----------------------------------------------------------
	public DBConnection(String connectionStr, String login, String passwd)
	{
		this.connPollerState = connPollerState;
		this.conn = null;
		this.connectionStr = connectionStr;
		this.connectionStr = connectionStr;
		this.login = login;
		this.passwd = passwd;
	}
	
	//-----------------------------------------------------------
	public synchronized Connection set(Connection conn)
	{
		this.conn = conn;
		return this.conn;
	}

	//-----------------------------------------------------------
	public synchronized Connection get()
	{
		return conn;
	}

        //-----------------------------------------------------------
        public void run()
        {
		while(connPollerState.test())
		{
			try {
                                initDBConnection(login, passwd);
                        } catch (ThrowableString ex) {
                                System.out.println(ex.getMessage());
                                return;
                        }

			if (get() == null)
			{
				try {
					sleep(5 * 1000);          // thousands of one second
				} catch (InterruptedException ie) {
					System.err.println("TBDB.FilePoller::run() - InterruptedException on call to sleep()");
				}
			}
		}
                System.out.println("TBDB.DBConnection::run() - got connection exiting connection poller");
	}

        //-----------------------------------------------------------
        public void initDBConnection(String login, String passwd) throws ThrowableString
        {
         Connection dbCon = null;

                System.out.println("TBDB.DBConnection::initDBConnection()");

                try {
                        if (dbCon != null)
                        {
                                dbCon.close();
                                dbCon = null;
                        }
                        DriverManager.registerDriver(new oracle.jdbc.driver.OracleDriver());
                        dbCon = DriverManager.getConnection (connectionStr, login, passwd);

                } catch (SQLException ex) {
                        throw new ThrowableString("Servlet::initDBConnection() - ERR: " + ex.getMessage() + " to: " + connectionStr);
                }
										// if we got this far then we should have 
										// a valid connection to a db
		set(dbCon);
		connPollerState.reset();					// will stop the poller and tell the parent 
										// we have a connection
        }
}


