
//-----------------------------------------------------------
//
//	Softbolts Ltd. (c) all rights reserved
//
//	Warning: This  program is  protected by copyright law 
//		 and   international  treaties.  Unauthorised
//		 reproduction or distribution of this program,
//		 or  any portion  or it, may result in severe
//		 civil  and  criminal  penalties, and will be
//		 prosecuted to  the  maximum extent possible.
//
//              Author: A. E. Dawson, Aug 1999
//              mailto: anthony@softbolts.com
//
//		Last Revised: 3 July 2002
//
//-----------------------------------------------------------

package com.softbolts.connectors.TBFile;

import com.softbolts.lib.*;

import java.io.*;
import java.util.*;
import java.lang.*;


public class FileObj extends ServletObj implements Serializable
{
 Servlet svr = null;

	//-----------------------------------------------------------
	FileObj(Servlet svr)
	{
		this.svr = svr;
	}

	//-----------------------------------------------------------
	public int run(NameValueTyp params) throws ThrowableString
	{
	 String method = null;

		if((method = (String) params.get("sysMethod")) == null) return -1;
		if (method.equals("Get")) return Get(params);
		if (method.equals("Set")) return Set(params);
		return 0;
	}

	//-----------------------------------------------------------
	public int Get(NameValueTyp params) throws ThrowableString
	{
	 String data = new String();
	 int c;

		if (!params.containsKey("File Name"))
			throw new ThrowableString("FileObj::Get() - missing File Name parameter\n");

		String fn = ((ServletParamInfo) svr.configParams.get(svr.keyDirectoryName)).value + 
				"/" + params.get("File Name");
		if (((ServletParamInfo) svr.configParams.get(svr.keyBinaryOrText)).value.toUpperCase().equals("T"))
		{
			try {
				FileReader fr = new FileReader(fn);
				while ((c = fr.read()) > 0)
					data += (char) c;
				fr.close();
			} catch (FileNotFoundException fnf) {
				throw new ThrowableString("");
			} catch (IOException ioe) {
				throw new ThrowableString("PersistStream::read() - IO exception" + ioe.getMessage());
			}
			params.put("Data", data);
			params.put("Data Size", Integer.toString(data.length()));
		}
                else if (((ServletParamInfo) svr.configParams.get(svr.keyBinaryOrText)).value.toUpperCase().equals("B"))
                {                                                                       // binary file transfer using remote sockets
                        System.err.println("ERR: binary file transfer not yet implemented");
                        //throw new ThrowableString("FileObj::Set() - binary file transfer not yet implemented!");
                        return -1;
                }
                else
                {
                        System.err.println("FileObj::Set() - ERR: " + svr.keyBinaryOrText + " incorrectly set");
                        return -1;
                }

		return 0;
	}

	//-----------------------------------------------------------
	public int Set(NameValueTyp params) throws ThrowableString
	{
		if (!params.containsKey("File Name"))
		{
			params.remove("Data");
                        throw new ThrowableString("FileObj::Get() - missing File Name parameter\n");
		}

		if (!params.containsKey("Data"))  // also tells us its not a binary transfer
		{
			params.remove("Data");
                        throw new ThrowableString("FileObj::Get() - missing Data parameter\n");
		}

		if (!params.containsKey("Data Size"))
		{
			params.remove("Data");
                        throw new ThrowableString("FileObj::Get() - missing Data Size parameter\n");
		}
		String fn = ((ServletParamInfo) svr.configParams.get(svr.keyDirectoryName)).value + 
					"/" + params.get("File Name");
		try {
			FileWriter fw = new FileWriter(fn);
			fw.write((String) params.get("Data"));
			fw.close();
		} catch (FileNotFoundException fnf) {
			throw new ThrowableString("");
		} catch (IOException ioe) {
			throw new ThrowableString("PersistStream::read() - IO exception" + ioe.getMessage());
		}

		params.remove("Data");
		params.remove("Directory Name");

		return 0;
	}
}


