
//-----------------------------------------------------------
//
//	Softbolts Ltd. (c) all rights reserved
//
//	Warning: This  program is  protected by copyright law 
//		 and   international  treaties.  Unauthorised
//		 reproduction or distribution of this program,
//		 or  any portion  or it, may result in severe
//		 civil  and  criminal  penalties, and will be
//		 prosecuted to  the  maximum extent possible.
//
//              Author: A. E. Dawson, 15 Oct 1999
//              mailto: anthony@softbolts.com
//
//		Last Revised: 15 Oct 2002
//
//-----------------------------------------------------------


package com.softbolts.connectors.TBGenericDB;

import com.softbolts.lib.*;
import java.io.*;
import java.net.*;
import java.util.*;
import java.lang.Throwable;

public class Servlet extends BaseServlet
{
	public Servlet(String args[])
	{
		System.out.println("TBGenericDB Connector Started...");

		BillingDB bd = new BillingDB();

		servletName = "TBGenericDB";
		servletType = SvrTyp.connector;
                if (servletState == RunStatusTyp.running)
                        System.out.println("TBGenericDB Connector status is running...");
                else if (servletState == RunStatusTyp.halted)
                        System.out.println("TBGenericDB Connector status is halted...");
                else
                        System.out.println("TBGenericDB Connector status is undefined...");

		servletState = RunStatusTyp.running;

		AddConfigParam("Login", 20, "^[A-Za-z0-9_]*$", true);
		AddConfigParam("Password", 20, "^[A-Za-z0-9_]*$", false);

		//AddObject("BillingAccount");
		AddField("BillingAccount", "Key1");
		AddField("BillingAccount", "Name");
		AddField("BillingAccount", "Surname");
		AddField("BillingAccount", "Address1");
		AddField("BillingAccount", "Address2");
		AddField("BillingAccount", "Address3");
		AddField("BillingAccount", "Status");

		AddMethod("BillingAccount", "Get", bd);
		AddMethod("BillingAccount", "Set", bd);
		AddMethod("BillingAccount", "Create_Account", bd);
		AddMethod("BillingAccount", "Update_Account", bd);
		AddMethod("BillingAccount", "Delete_Account", bd);

		//-----------------------------------
		//AddObject("BillingBankDetails");
		//AddField("BillingBankDetails", "Key1");
		//AddField("BillingBankDetails", "Name");
		//AddField("BillingBankDetails", "Surname");

		//AddMethod("BillingBankDetails", "Get", b);
		//AddMethod("BillingBankDetails", "Set", b);
		//AddMethod("BillingBankDetails", "Create_BankDetails", b);
		//AddMethod("BillingBankDetails", "Update_BankDetails", b);
		//AddMethod("BillingBankDetails", "Delete_BankDetails", b);
	}

        //-----------------------------------------------------------
        public void service(NameValueTyp params) throws ThrowableString
        {
        }

	//-----------------------------------------------------------
	public void init(NameValueTyp params) throws ThrowableString
	{
		//System.out.println("init()");
		//throw new ThrowableString("ERR: init() - TBGenericDB - need to write some code here!");
	}

	//-----------------------------------------------------------
	public void finish(NameValueTyp params) throws ThrowableString
	{
		System.out.println("TBGenericDB.finish()");
		System.out.println("TBGenericDB Connector Stopped...");
	}

	//-----------------------------------------------------------
	public void beginTransaction(NameValueTyp params) throws ThrowableString
	{
	}

	//-----------------------------------------------------------
	public void commitTransaction(NameValueTyp params) throws ThrowableString
	{
	}

	//-----------------------------------------------------------
	public void rollBackTransaction(NameValueTyp params) throws ThrowableString
	{
	}
}


