
//-----------------------------------------------------------
//
//	Softbolts Ltd. (c) all rights reserved
//
//	Warning: This  program is  protected by copyright law 
//		 and   international  treaties.  Unauthorised
//		 reproduction or distribution of this program,
//		 or  any portion  or it, may result in severe
//		 civil  and  criminal  penalties, and will be
//		 prosecuted to  the  maximum extent possible.
//
//              Author: A. E. Dawson, March 2003
//              mailto: anthony@softbolts.com
//
//		Last Revised: 4th March 2003
//
//-----------------------------------------------------------

package com.softbolts.connectors.TBHTTP;

import com.softbolts.lib.*;

import java.io.*;
import java.util.*;
import java.lang.*;
import java.lang.reflect.*;
import java.net.*;


public class HTTPServlet extends Thread 
{
 SocketObj sok = null;
 int port = 0;
 String modelName = "";
 PollerState keepRunning = null;
 Vector msg = null;
 byte   CRLF[]      = { ((byte) 13), ((byte) 10) } ;
 BaseServlet svr;

        //-----------------------------------------------------------
	/**
	* A very rudimentary example of a portal which when triggered
	* by a GET request triggers a transaction execution and displays
	* an HTML page based on a customers maximum credit line.
	* The logic of which HTML page to display is modeled in the 
	* transaction specification and is determined as the transaction
	* is executed. The names of the which HTML page to display is held
	* in the database. CCDB1.CUSTOMER_CREDIT_LINE.
	* This connector model should be configured as HTTPExample1.
	* ensure that the HTTPExample.trs tranaction spec file is present in
	* $(M_WARE_PATH)/TransSpec
	*/
        public HTTPServlet(BaseServlet svr, int port, String modelName, PollerState keepRunning) throws ThrowableString
        {
		//this.svr = (BaseServlet) svr.clone();
		try {
                        this.svr = (BaseServlet) ObjectCloner.deepCopy(svr);
                                                        // these don't appear to be properly copied
                                                        // by the deep cloner.... search me why!
							// if what is being assigned is a reference
							// we are in trubble!
                        this.svr.servletState = svr.servletState;
                        this.svr.servletType = svr.servletType;
                        this.svr.procMode = svr.procMode;
                        this.svr.protocol = svr.protocol;
                } catch (Exception e) {
                        System.err.println(e);
                }

		this.port = port;
		this.keepRunning = keepRunning;
		this.modelName = modelName;
		keepRunning.set();
		System.err.println("Creating HTTP servlet on port " + port);
                try {
                        sok = new SocketObj(port);
			sok.setPtotocol(ProtocolTyp.http);
                } catch (ThrowableString s) {
                        throw new ThrowableString(s.getMessage());
                }
		msg = new Vector(10);
        }

        //-----------------------------------------------------------
        public void run()
        {
	 NameValueTyp r = new NameValueTyp();

		System.err.println("Running HTTP servlet");
		String str = "";
		String name = "";
		String surname = "";
		while(keepRunning.test() == true)
		{
			msg.clear();
			str = "";
			name = "";
			surname = "";
			r.clear();

                        try {
				System.err.println("HTTP Servlet waiting for a connection");
                                sok.getConnection();
				// TO DO handle requests independently
				// TO DO handling of persistent requests
				// TO DO handling of chunking
				//System.err.println("Got a connection");
                                sok.read(msg);
				if (sok.connected == false) continue;

				// TO DO parse the incoming requests properly!
				//System.out.println("HTTPServlet::run() - msg is: " + msg);
				if (((String) msg.elementAt(0)).indexOf("GET / HTTP/1") != -1)
				{
					sok.writeBinaryFile("./html/index.htm");
				}
				else if (((String) msg.elementAt(0)).indexOf("GET /ThunderboltLogo.jpg HTTP/1") != -1)
				{
//System.out.println("About to**************** ");
					sok.writeBinaryFile("./html/logoheader");
//System.out.println("Written Header**************** ");
					sok.writeBinaryFile("./html/ThunderboltLogo.jpg");
//System.out.println("Written**************** ");
				}
				else if ((str = (String) msg.elementAt(0)).indexOf("GET /getcredit") != -1)
				{
					//String params = URLDecoder.decode(str.substring(str.indexOf('/'), str.length()), "US-ASCII");
System.out.println("PARAMS! " + str);
					if (str.indexOf('+') == -1)
						sok.writeBinaryFile("./html/NameSurnameRequired.htm");
					else
					{
						name = str.substring(str.indexOf('=') + 1, str.indexOf('+'));
						try {
							if (str.indexOf('&') != -1) 
							{
								//System.out.println("Hello1!");
								surname = str.substring(str.indexOf('+') + 1, str.indexOf('&'));
							}
							else if (str.indexOf(' ', str.indexOf('+')) != -1) 
							{
								//System.out.println("Hello2!");
								surname = str.substring(str.indexOf('+') + 1, str.indexOf(' ', str.indexOf('+')));
							}
							else 
							{
								//System.out.println("Hello3!");
								surname = str.substring(str.indexOf('+') + 1, str.length());
							}
						} catch (StringIndexOutOfBoundsException ex) {
							System.out.println("HTTPServlet::run() - StringIndexOutOfBoundsException " + 
										ex.getMessage());
							sok.writeBinaryFile("./html/AnErrorOccurred.htm");
							sok.close();
							continue;
						}
					//System.out.println("HTTPServlet::run() - name is: " + name);
					//System.out.println("HTTPServlet::run() - surname is: " + surname);
						//sok.writeBinaryFile("./html/ServiceNotAvailable.htm");
						r.put("SQL_STATEMENT", "select * from customer_credit_line where name = '" + 
							name + "' and surname = '" + surname + "'");
						System.out.println("HTTPServlet::run() - Statement is: " + r.get("SQL_STATEMENT"));
						
						try {
							r = Utils.runModel(r, svr, modelName, true, true);
						} catch (ThrowableString s) {
							System.err.println("HTTPServlet::run() - Exception " + s.getMessage());
							continue;
						}
						try {
							if (r.containsKey("DISPLAY_HTML") == false)
								sok.writeBinaryFile("./html/NoCreditFound.htm");
							else 
								sok.writeBinaryFile(r.get("DISPLAY_HTML"));
						} catch (ThrowableString ts) {
							System.out.println("HTTPServlet::run() - Error wtiting out the reply");
						}
					}
				}
				sok.close();

                        } catch (ThrowableString s) {
				System.err.println(s.getMessage());
                        }

			Enumeration e = msg.elements();
			while (e.hasMoreElements())
			{
				System.err.print((String) e.nextElement());
			}

		}
		System.err.println("Stopping HTTP Servlet");
	}
}

