
//-----------------------------------------------------------
//
//      Softbolts Ltd. (c) all rights reserved
//
//      Warning: This  program is  protected by copyright law
//               and   international  treaties.  Unauthorised
//               reproduction or distribution of this program,
//               or  any portion  or it, may result in severe
//               civil  and  criminal  penalties, and will be
//               prosecuted to  the  maximum extent possible.
//
//              Author: A. E. Dawson, Aug 1999
//              mailto: anthony@softbolts.com
//
//              Last Revised: 3 July 2002
//
//-----------------------------------------------------------

package com.softbolts.lib;

import java.io.*;
import java.util.*;
import java.awt.*;

public class ObjectCloner
{
   								// so that nobody can accidentally create an ObjectCloner object
   private ObjectCloner(){}
								// returns a deep copy of an object
   static public Object deepCopy(Object oldObj) throws Exception
   {
      ObjectOutputStream oos = null;
      ObjectInputStream ois = null;
      try
      {
         ByteArrayOutputStream bos = new ByteArrayOutputStream();			// A
         oos = new ObjectOutputStream(bos);			// B
								// serialize and pass the object
         oos.writeObject(oldObj);   				// C
         oos.flush();               				// D
         ByteArrayInputStream bin = 
               new ByteArrayInputStream(bos.toByteArray());	// E
         ois = new ObjectInputStream(bin);                 	// F
         							// return the new object
         return ois.readObject();				// G
      }
      catch(Exception e)
      {
         System.out.println("Exception in ObjectCloner = " + e);
         throw(e);
      }
      finally
      {
         oos.close();
         ois.close();
      }
   }
}
