
//-----------------------------------------------------------
//
//	Softbolts Ltd. (c) all rights reserved
//
//	Warning: This  program is  protected by copyright law 
//		 and   international  treaties.  Unauthorised
//		 reproduction or distribution of this program,
//		 or  any portion  or it, may result in severe
//		 civil  and  criminal  penalties, and will be
//		 prosecuted to  the  maximum extent possible.
//
//              Author: A. E. Dawson, Aug 1999
//              mailto: anthony@softbolts.com
//
//		Last Revised: 3 July 2002
//
//-----------------------------------------------------------

package com.softbolts.lib;

import java.io.*;
import java.net.*;
import java.util.*;
import java.lang.*;

public class PersistStream implements Serializable
{
 String fileName = null;
 FileInputStream in = null;
 FileOutputStream out = null;


	//-----------------------------------------------------------
	public PersistStream(String fn) throws ThrowableString
	{
		fileName = fn;
	}           

	//-----------------------------------------------------------
	static public void printMap(NameValueTyp data)
	{
	 Enumeration e = data.keys();
	 String key, value;

		System.err.println("---------------Print Map------------------------");
		while (e.hasMoreElements())
		{
			key = (String) e.nextElement();
			value = (String) data.get(key);
			System.err.println(key + " -> " + value);
		}
		System.err.println("----------------------------------------");
	}

	//-----------------------------------------------------------
	public ConfigParamTyp read() throws ThrowableString
	{
	  ConfigParamTyp params = null;
		try {
			in = new FileInputStream(fileName);
			ObjectInputStream p = new ObjectInputStream(in);
			params = (ConfigParamTyp) p.readObject();
			in.close();
		} catch (FileNotFoundException fnf) { // not too bothered about this as this will 
						      // happen when is there is no conf file i.e. on a new
						      // connector before its configured for the first time
			//System.err.println("PersistStream::read() - FileNotFoundException: " + fnf.getMessage());
			throw new ThrowableString("");
		} catch (IOException ioe) {
			//System.err.println("PersistStream::read() - IO exception: " + ioe.getMessage());
			throw new ThrowableString("PersistStream::read() - IO exception " + ioe.getMessage());
		} catch (ClassNotFoundException cnf) {
			//System.err.println("PersistStream::read() - ClassNotFoundException: " + cnf.getMessage());
			throw new ThrowableString("PersistStream::read() - ClassNotFoundException: " + cnf.getMessage());
		}
/*
		} catch (InvalidClassException ice) {
			throw new ThrowableString("PersistStream::read() - InvalidClassException: " + ice.getMessage());
		} catch (StreamCorruptedException sce) {
			throw new ThrowableString("PersistStream::read() - StreamCorruptedException: " + sce.getMessage());
		} catch (OptionalDataException ode) {
			throw new ThrowableString("PersistStream::read() - OptionalDataException: " + ode.getMessage());
		}
*/
		
		return params;
	}           

	//-----------------------------------------------------------
	public void write(ConfigParamTyp params) throws ThrowableString
	{
		try {
			out = new FileOutputStream(fileName);
			ObjectOutputStream p = new ObjectOutputStream(out);
			p.writeObject(params);
			p.flush();
			out.close();
		} catch (FileNotFoundException fnf) {
			//System.err.println("Hello1");
			throw new ThrowableString("PersistStream::write() - file not found exception");
		} catch (IOException ioe) {
			//System.err.println("Hello2");
			throw new ThrowableString("PersistStream::write() - IO exception " + ioe.getMessage());
		}
	}           

	//-----------------------------------------------------------
	// I'm sure there is a better way to do this than rewriting the
	// same code but I can't think of it right now!
	//-----------------------------------------------------------
	// Same for TransactionListTyp
	//-----------------------------------------------------------
	public void read(TransactionListTyp params) throws ThrowableString
	{
		try {
			in = new FileInputStream(fileName);
			ObjectInputStream p = new ObjectInputStream(in);
			params = (TransactionListTyp) p.readObject();
			in.close();
		} catch (FileNotFoundException fnf) {
			throw new ThrowableString("");
		} catch (IOException ioe) {
			throw new ThrowableString("PersistStream::read() - IO exception" + ioe.getMessage());
		} catch (ClassNotFoundException cnf) {
			throw new ThrowableString("PersistStream::read() - " + cnf.getMessage());
		}
	}           

	//-----------------------------------------------------------
	public void write(TransactionListTyp params) throws ThrowableString
	{
		try {
			out = new FileOutputStream(fileName);
			ObjectOutputStream p = new ObjectOutputStream(out);
			p.writeObject(params);
			p.flush();
			out.close();
		} catch (FileNotFoundException fnf) {
			throw new ThrowableString("PersistStream::write() - file not found exception");
		} catch (IOException ioe) {
			throw new ThrowableString("PersistStream::write() - IO exception " + ioe.getMessage());
		}
	}           

	//-----------------------------------------------------------
	// Same for NameValueTyp
	//-----------------------------------------------------------
	public void read(NameValueTyp params) throws ThrowableString
	{
		try {
			in = new FileInputStream(fileName);
			ObjectInputStream p = new ObjectInputStream(in);
			params = (NameValueTyp) p.readObject();
			in.close();
		} catch (FileNotFoundException fnf) {
			throw new ThrowableString("");
		} catch (IOException ioe) {
			throw new ThrowableString("PersistStream::read() - IO exception" + ioe.getMessage());
		} catch (ClassNotFoundException cnf) {
			throw new ThrowableString("PersistStream::read() - " + cnf.getMessage());
		}
	}           

	//-----------------------------------------------------------
	public void write(NameValueTyp params) throws ThrowableString
	{
		try {
			out = new FileOutputStream(fileName);
			ObjectOutputStream p = new ObjectOutputStream(out);
			p.writeObject(params);
			p.flush();
			out.close();
		} catch (FileNotFoundException fnf) {
			throw new ThrowableString("PersistStream::write() - file not found exception");
		} catch (IOException ioe) {
			throw new ThrowableString("PersistStream::write() - IO exception " + ioe.getMessage());
		}
	}           
}


