
//-----------------------------------------------------------
//
//	Softbolts Ltd. (c) all rights reserved
//
//	Warning: This  program is  protected by copyright law 
//		 and   international  treaties.  Unauthorised
//		 reproduction or distribution of this program,
//		 or  any portion  or it, may result in severe
//		 civil  and  criminal  penalties, and will be
//		 prosecuted to  the  maximum extent possible.
//
//              Author: A. E. Dawson, Aug 1999
//              mailto: anthony@softbolts.com
//
//		Last Revised: 14 Oct 2002
//
//-----------------------------------------------------------

package com.softbolts.lib;

import java.lang.Thread.*;
import java.io.*;
import java.net.*;
import java.util.*;


//-----------------------------------------------------------
//-----------------------------------------------------------
public class QSemaphore {
 private int val;

	//-----------------------------------------------------------
	public QSemaphore() {
		val = 1;
	}

	//-----------------------------------------------------------
	public QSemaphore(int initVal) {
		val = initVal;
	}
	//-----------------------------------------------------------
	public synchronized void getSem() {
		while(val == 0) {
			try{
				super.wait();
			} catch(InterruptedException e) {}
		}
		val = 0;
	}
	//-----------------------------------------------------------
	public synchronized void releaseSem() {
		val = 1;
		super.notify();
	}
}
