//-----------------------------------------------------------
//
//	Softbolts Ltd. (c) all rights reserved
//
//	Warning: This  program is  protected by copyright law 
//		 and   international  treaties.  Unauthorised
//		 reproduction or distribution of this program,
//		 or  any portion  or it, may result in severe
//		 civil  and  criminal  penalties, and will be
//		 prosecuted to  the  maximum extent possible.
//
//              Author: A. E. Dawson, Aug 1999
//              mailto: anthony@softbolts.com
//
//		Last Revised: 14 Oct 2002
//
//-----------------------------------------------------------

package com.softbolts.lib;

import java.io.*;
import java.net.*;
import java.util.*;
import java.lang.*;
//import javax.xml.parsers.*;
//import org.xml.sax.*;
//import org.xml.sax.helpers.*;

//-----------------------------------------------------------
//-----------------------------------------------------------
public class Register
{
 private int i;
 private String key;
 private String buff;
 private boolean runStatus = true;			// to change should be sharable
 private static Thread cth = Thread.currentThread();	// get a handle to the current thread
 private SocketObj sok = null;
 //private Hashtable si  = null;  			// maps servlet typeName to the ServletSpec class si = servlet info
 //private ServletEnv se  = null;    			// contains the servlet environment variables se = node environment


	//-----------------------------------------------------------
	Register(BaseServlet svr, String requiredName) throws ThrowableString
	{
		System.err.println("*** Register() *** ");
		if (svr.servletType == SvrTyp.undefined)
			throw new ThrowableString("ERR: Register() - No servlet type specified!");

		if (svr.servletName.equals(""))
			throw new ThrowableString("ERR: Register() - No servlet name specified!");

		while (sok == null || ((sok.connected == false) && (runStatus == true)))
		{
			try {
				sok = new SocketObj(svr.enginePort, svr.engineHostName);
			} catch (IOException ioe) {
				System.err.println("No Engine Found");
				try {
					cth.sleep(2000);
				} catch (InterruptedException ie) {
					throw new ThrowableString("Register() - exception on call to sleep()");
				}
			}
		}

System.err.println("Socket connected OK");

		if (runStatus == false)
			throw new ThrowableString("Register() - runStatus = false");

		String servletTypeName = null;
		String servletScript = null;
		NameValueTyp strmap = new NameValueTyp();
		if (svr.servletType == SvrTyp.node)
		{
/*
										// read in the servlet specifications from the 
										// servlets.xml file
			SAXParserFactory spf = SAXParserFactory.newInstance();
			spf.setValidating(false);
			spf.setNamespaceAware(true);
			try {
										// parse the document
				SAXParser parser = spf.newSAXParser();
				DefaultHandler handler = new XMLStreamHandler();
				InputSource source = new InputSource(new FileReader("./config/servlets.xml"));
				parser.parse(source, handler);

				si = ((XMLStreamHandler) handler).getServletSpec();
				se = ((XMLStreamHandler) handler).getServletEnv();

			} catch (Exception ex) {
				ex.printStackTrace(System.err);
				System.exit(0);
			}
*/

			Hashtable si = ((XMLStreamHandler) svr.handler).getServletSpec();
			Enumeration e = si.keys();
			int i = 0;
			String key = null;
			//ServletSpec value;
			while (e.hasMoreElements())
			{
				key = (String) e.nextElement();
				strmap.put("sysServletType" + Integer.toString(i++), key);

				//value = (ServletSpec) si.get(key);
				//System.out.println(key + " -> " + value.script);
				//System.out.println(key + " -> " + value.runMode);
			}
		}

		strmap.put("sysRequest", "Register Servlet");           // The service on the engine which enables us to register
		if (requiredName.equals("") == false)
			strmap.put("sysRequestedName", requiredName);	// The instance name we'd like assigned to this servlet
		strmap.put("sysDebug", "True");                         // Turn debugging trace on
		strmap.put("sysReply", "True");                         // Make sure we get a reply
		strmap.put("sysClientId", svr.servletName);             // A client id to identify who is sending the message
		strmap.put("sysServletTypeName", svr.servletName);      // The name which identifies this connector
		strmap.put("sysServletType", svr.servletType.getString());  // The name which identifies this connector
		strmap.put("sysServletHostName", svr.servletHostName);  // Host name where to find the connector

									  // If we have a port number then tell the engine
		if (svr.ourPort != 0)
		{
			strmap.put("sysAssignedPort", Integer.toString(svr.ourPort));
		}

		sok.write(strmap);
		strmap.clear();
		sok.read(strmap);

		if (!sok.connected)
			throw new ThrowableString("Socket closed by other side");

		sok.close();

		System.err.println("------------------------------------------------");
		System.err.println(svr.procName + " DATA RETURNED BY ENGINE:");
                PersistStream.printMap(strmap);


		if (!strmap.get("sysResultString").equals("OK"))
			throw new ThrowableString("Register()- Registering connector with Engine!");

		if (strmap.containsKey("sysAssignedPort") == false)
			throw new ThrowableString("Register()- Engine did not assign a socket number as expected!");

		if (strmap.containsKey("sysAssignedName") == false)
			throw new ThrowableString("Register()- Engine did not assign a name cannot save configuration!");

		Integer i = new Integer((String) strmap.get("sysAssignedPort"));
		int ourPort = i.intValue();
		svr.ourPort = ourPort;
		svr.assignedName = (String) strmap.get("sysAssignedName");

	System.err.println("Registered Servlet with Engine OK");
	System.err.println("Engine assigned socket id: " + ourPort);
	System.err.println("Engine assigned name     : " + strmap.get("sysAssignedName"));

		        // Check and see if there are any configuration parameters saved previously for us
		String fn = System.getProperty("M_WARE_CONFIGDIR") + "/" + svr.assignedName + ".cfg";

		try {
			//PersistStream ps = new PersistStream(fn, ios::in);
			PersistStream ps = new PersistStream(fn);
			svr.configParams = ps.read();
		} catch (ThrowableString s) {
			if (s.equals(""))
				System.err.println("Register::Register() - No configuration parameters found for servlet");
			else
				System.err.println(s);
		}
	}

	//-----------------------------------------------------------
	Register(SocketObj sok, BaseServlet svr) throws ThrowableString
	{
	}
}


