//-----------------------------------------------------------
//
//	Softbolts Ltd. (c) all rights reserved
//
//	Warning: This  program is  protected by copyright law 
//		 and   international  treaties.  Unauthorised
//		 reproduction or distribution of this program,
//		 or  any portion  or it, may result in severe
//		 civil  and  criminal  penalties, and will be
//		 prosecuted to  the  maximum extent possible.
//
//              Author: A. E. Dawson, Aug 1999
//              mailto: anthony@softbolts.com
//
//		Last Revised: 07 Nov 2002
//
//-----------------------------------------------------------

package com.softbolts.lib;

import java.io.*;
import java.net.*;
import java.util.*;
import java.lang.*;

public class ServletRunnerThread extends Thread
{
 SocketObj sok;
 NameValueTyp r;
 DateTime dt;
 BaseServlet svr;
 QSemaphore tidFileSem;
 RequestExecuter runner = null;

	//-----------------------------------------------------------
	public ServletRunnerThread(QSemaphore tidFileSem, Socket s, 
				BaseServlet svr, NameValueTyp r) throws ThrowableString
	{
		// Class cloning is not necessary as java passes classe objects by value not
		// by reference so effectively they already are copies..?? Or are they??
		this.tidFileSem = tidFileSem;
		this.sok = new SocketObj(s);
		//this.svr = (BaseServlet) svr.clone();

/*
		synchronized (this) {
                    if (logger != null) {
                        logger.shutdown();
                }
*/

		try {
			this.svr = (BaseServlet) ObjectCloner.deepCopy(svr);
							// these don't appear to be properly copied 
							// by the deep cloner.... search me why!
			this.svr.servletState = svr.servletState;
			this.svr.servletType = svr.servletType;
			this.svr.procMode = svr.procMode;
			this.svr.protocol = svr.protocol;
			this.r = (NameValueTyp) ObjectCloner.deepCopy(r);
		} catch (Exception e) {
			System.err.println(e);
		}
/*
                if (this.svr.servletType == SvrTyp.undefined || this.svr.servletType == SvrTyp.transformer || 
			this.svr.servletType == SvrTyp.node || this.svr.servletType == SvrTyp.monitor || 
			this.svr.servletType == SvrTyp.connector)
                        System.out.println("*** VALID");
                else
                        System.out.println("*** NOT VALID");

                if (this.svr.servletState == RunStatusTyp.running || this.svr.servletState == RunStatusTyp.halted)
                        System.out.println("*** RUN STATUS IS VALID");
		else
                        System.out.println("*** RUN STATUS IS NOT VALID");
*/
		runner = new RequestExecuter(this.tidFileSem, this.sok.getSocket(), this.svr, this.r);
		//RequestExecuter runner = new RequestExecuter(tidFileSem, s, svr, r);
	}           

	//-----------------------------------------------------------
	public void run()
	{
			System.err.println("Hello 4");
		runner.run();
	}           
}

