//-----------------------------------------------------------
//
//	Softbolts Ltd. (c) all rights reserved
//
//	Warning: This  program is  protected by copyright law 
//		 and   international  treaties.  Unauthorised
//		 reproduction or distribution of this program,
//		 or  any portion  or it, may result in severe
//		 civil  and  criminal  penalties, and will be
//		 prosecuted to  the  maximum extent possible.
//
//              Author: A. E. Dawson, Aug 1999
//              mailto: anthony@softbolts.com
//
//		Last Revised: 14 Oct 2002
//
//-----------------------------------------------------------

package com.softbolts.lib;

import java.io.*;
import java.net.*;
import java.util.*;

//-----------------------------------------------------------
public class SvrTyp implements Serializable {
    private final String name;
    private SvrTyp(String name) { this.name = name; }
    public String toString()  { return name; }
								// ** NOTE ** must match the definition in ../lib/MWTypes.hh
    public static final SvrTyp undefined = new SvrTyp("0");
    public static final SvrTyp connector = new SvrTyp("1");
    public static final SvrTyp transformer = new SvrTyp("2");
    public static final SvrTyp node = new SvrTyp("3");
    public static final SvrTyp monitor = new SvrTyp("4");
    public final String getString() { return this.name; }
}


