
//-----------------------------------------------------------
//
//	Softbolts Ltd. (c) all rights reserved
//
//	Warning: This  program is  protected by copyright law 
//		 and   international  treaties.  Unauthorised
//		 reproduction or distribution of this program,
//		 or  any portion  or it, may result in severe
//		 civil  and  criminal  penalties, and will be
//		 prosecuted to  the  maximum extent possible.
//
//              Author: A. E. Dawson, Aug 2003
//              mailto: anthony@softbolts.com
//
//		Last Revised: 09 May 2003
//
//-----------------------------------------------------------

package com.softbolts.lib;

import java.io.*; 
import java.util.*;
import java.lang.*;
import org.xml.sax.*;
import org.xml.sax.helpers.*;


/**
 * SAX2 handler for parsing trade history information stream.
 *
 * @author Anthony E. Dawson
 * @version 1.0
 */

public class XMLStreamHandler extends DefaultHandler implements Serializable 
{
	protected static final String HOME_DIR = "tmpdir";
	protected static final String TMP_DIR = "tmpdir";
	protected static final String TID_DIR = "tiddir";
	protected static final String LOG_DIR = "logdir";
	protected static final String CONFIG_DIR = "configdir";
	protected static final String ENGINE_HOST = "enginehost";
	protected static final String ENGINE_PORT = "engineport";
	protected static final String SERVLET = "servlet";
	protected static final String SERVLET_NAME = "name";
	protected static final String RUN_MODE = "runmode";
	protected static final String RUN_SCRIPT = "script";
	protected static final String PROPERTY = "property";

	ServletEnv	ne = null;
	Hashtable	si = null;
	
	//-----------------------------------------------------------
	public XMLStreamHandler()
	{
		si = new Hashtable();
		ne = new ServletEnv();
	}

	//-----------------------------------------------------------
	public void startElement(String uri, String lname, String qname, Attributes attributes)
	{
	 String attrName = null;
	 String attrValue = null;

//System.out.println("uri: " + uri);
//System.out.println("lname: " + lname);
//System.out.println("qname: " + qname);

		if (lname.equals(PROPERTY))
		{
			System.out.println("-------------------------------------");
			int numberOf = attributes.getLength();
			for (int i = 0; i < numberOf; i++)
			{
				attrName = attributes.getLocalName(i);
				attrValue = attributes.getValue(i);
				System.out.println("Attr Name: " + attrName);
				System.out.println("Attr value: " + attrValue);
				if (attrName.equals(TMP_DIR))
					ne.tmpdir = attrValue;
				else if (attrName.equals(TID_DIR))
					ne.tiddir = attrValue;
				else if (attrName.equals(LOG_DIR))
					ne.logdir = attrValue;
				else if (attrName.equals(CONFIG_DIR))
					ne.configdir = attrValue;
				else if (attrName.equals(ENGINE_HOST))
					ne.enginehost = attrValue;
				else if (attrName.equals(ENGINE_PORT))
					ne.engineport = attrValue;
			}
		}
		else if (lname.equals(SERVLET))
		{
			ServletSpec s = new ServletSpec();
			String typeName = null;
			int numberOf = attributes.getLength();
//System.out.println("-------------------------------------");
			for (int i = 0; i < numberOf; i++)
			{
				attrName = attributes.getLocalName(i);
				attrValue = attributes.getValue(i);
//System.out.println("Attr Name: " + attrName);
//System.out.println("Attr value: " + attrValue);
				if (attrName.equals(SERVLET_NAME))
					typeName = attrValue;
				else if (attrName.equals(RUN_MODE))
					s.runMode = attrValue;
				else if (attrName.equals(RUN_SCRIPT))
					s.script = attrValue;
			}
			si.put(typeName, s);
		}
//System.out.println("-------------------------------------");
	}
	
	
	//-----------------------------------------------------------
	public Hashtable getServletSpec()
	{
		return si;
	}

	//-----------------------------------------------------------
	public ServletEnv getServletEnv()
	{
		return ne;
	}

	//-----------------------------------------------------------
	public void characters(char[] chars, int start, int length)
	{
		//System.out.println(chars);
	}
	
	//-----------------------------------------------------------
	public void endElement(String uri, String lname, String qname)
	{
	}
}

