
//-----------------------------------------------------------
//
//	Softbolts Ltd. (c) all rights reserved
//
//	Warning: This  program is  protected by copyright law 
//		 and   international  treaties.  Unauthorised
//		 reproduction or distribution of this program,
//		 or  any portion  or it, may result in severe
//		 civil  and  criminal  penalties, and will be
//		 prosecuted to  the  maximum extent possible.
//
//              Author: A. E. Dawson, March 2003
//              mailto: anthony@softbolts.com
//
//		Last Revised: 4th March 2003
//
//-----------------------------------------------------------

package com.softbolts.monitors.TBMonitor;

import com.softbolts.lib.*;

import java.io.*;
import java.util.*;
import java.lang.*;
import java.sql.*;


public class MonitorPoller extends Thread 
{
 PollerState pollerState = null;
 int pollingInterval = 0;
 BaseServlet p = null;
 NameValueTyp tmpMap = null;


        //-----------------------------------------------------------
        //public MonitorPoller(PollerState pollerState, int pollingInterval, String instanceName BaseServlet p) throws ThrowableString
        public MonitorPoller(PollerState pollerState, int pollingInterval, Servlet p) throws ThrowableString
        {
		this.pollerState = pollerState;
		this.pollingInterval = pollingInterval;
		this.p = p;
		tmpMap = new NameValueTyp();
		p.pollerState.set();
        }

        //-----------------------------------------------------------
        public void Sleep(long interval)
        {
		try {
			sleep(interval);		// thousands of one second
		} catch (InterruptedException ie) {
			System.err.println("TBMonitor.MonitorPoller::run() - InterruptedException on call to sleep()");
		}
	}

        //-----------------------------------------------------------
        public void run()
        {
	 NameValueTyp params = new NameValueTyp();
	 SocketObj sok = null;

		System.err.println("TBMonitor.MonitorPoller::run()");
		System.err.println("TBMonitor.MonitorPoller::run() - Querying engine for servlet set to Monitor");
		if (getServletList(params) == -1)
		{
			p.servletState = RunStatusTyp.halted;
			return;
		}
		

System.err.println("---------LIST OF SERVLETS TO MONITOR-------");
PersistStream.printMap(params);
System.err.println("-------------------------------------------");

		String servletInstanceName = "";
		int i;
		String ndx = "";
		while (pollerState.test())
		{
			System.out.println("TBMonitor.MonitorPoller::run() -> " + p.assignedName + " Polling...");
			System.err.println("TBMonitor.MonitorPoller::run() -> " + p.assignedName + " Polling...");

			for (i = 0, ndx = Integer.toString(i);
				params.containsKey("sysServletInstanceName" + ndx) && pollerState.test();
				i++, ndx = Integer.toString(i))
			{
				//ndx = Integer.toString(i);
				tmpMap.clear();
				tmpMap.put("sysRequest", "Ping");
				tmpMap.put("sysClientId", p.assignedName);
				tmpMap.put("sysPingedServlet", params.get(servletInstanceName + ndx));
				tmpMap.put("sysDebug", "True");
				tmpMap.put("sysReply", "True");

				ndx = Integer.toString(i);
System.out.println("-------------------------------------------");
System.out.println("Pinging: " + params.get("sysServletInstanceName" + ndx));
System.out.println("Host   : " + params.get("sysServletHost" + ndx));
System.out.println("Port   : " + params.get("sysServletPort" + ndx));
System.out.println("-------------------------------------------");
				try {
					sok = new SocketObj(Integer.parseInt(params.get("sysServletPort" + ndx)), 
								params.get("sysServletHost" + ndx));
					if (sok.connected)
					{
						sok.write(tmpMap);
						sok.read(tmpMap);
						sok.close();
					}
					else // (!sok.connected)
					{
						tmpMap.put("sysResultStatus", "-1");
						tmpMap.put("sysResultString", "Socket Connection failed");
					}

				} catch (ThrowableString e) {
					tmpMap.put("sysResultStatus", "-1");
					System.err.println("MonitorPoller::run() - " + e.getMessage());
				} catch (IOException ioe) {
					tmpMap.put("sysResultStatus", "-1");
					System.err.println("MonitorPoller::run() - No Engine Found " + ioe.getMessage());
				}

				if (tmpMap.containsKey("sysResultStatus") && tmpMap.get("sysResultStatus").equals("-1"))
				{
					System.err.println("TBMonitor.MonitorPoller::run() - No reply from " +
								 params.get("sysServletInstanceName" + ndx) + 
								" on host: " + params.get("sysServletHost" + ndx) +
								" on port: " + params.get("sysServletPort" + ndx));
					System.err.println("Marking OFFLINE!");
					if (markServletOffline(params.get("sysServletInstanceName" + ndx),
							params.get("sysServletHost" + ndx)) != -1)
						getServletList(params);
				}
			Sleep(1 * 1000);
			}
			//Sleep(pollingInterval * 1000);
			Sleep(5 * 1000);
		}

		System.out.println("TBmonitor.MonitorPoller::run() - Poller stopping");
		System.err.println("TBmonitor.MonitorPoller::run() - Poller stopping");

		pollerState.set();
	}

        //-----------------------------------------------------------
	private int markServletOffline(String servletInstanceName, String host)
	{
	 SocketObj sok = null;
	 NameValueTyp tmpMap = new NameValueTyp();

			tmpMap.clear();
			tmpMap.put("sysRequest", "Mark Servlet Unavailable");
			tmpMap.put("sysHostName", host);
			tmpMap.put("sysInstanceName", servletInstanceName);
			tmpMap.put("sysClientId", p.assignedName);
			tmpMap.put("sysDebug", "True");
			tmpMap.put("sysReply", "True");

			try {
				sok = new SocketObj(p.enginePort, p.engineHostName);
				if (sok.connected)
				{
					sok.write(tmpMap);
					sok.read(tmpMap);
					sok.close();
				}
				else // (!sok.connected)
				{
					tmpMap.put("sysResultStatus", "-1");
					tmpMap.put("sysResultString", "Socket Connection failed");
				}

			} catch (ThrowableString e) {
				tmpMap.put("sysResultStatus", "-1");
				System.err.println("MonitorPoller::run() - " + e.getMessage());
			} catch (IOException ioe) {
				tmpMap.put("sysResultStatus", "-1");
				System.err.println("MonitorPoller::run() - No Engine Found " + ioe.getMessage());
			}

			if (tmpMap.containsKey("sysResultStatus") && tmpMap.get("sysResultStatus").equals("-1"))
			{
				System.err.println("TBMonitor.MonitorPoller::markServletOffline() - failed");
				return -1;
			}
			return 0;
	}

	//-----------------------------------------------------------
	private int getServletList(NameValueTyp params)
	{
	 SocketObj sok = null;
	 int attempts = 10;			// make N attempts to get the connector listing from the engine
						// after which its ciao for now and wil have to be restarted 
						// manually or from the console
	 boolean failed = true;

		while (attempts > 0 && failed && pollerState.test())
		{
			params.clear();
			params.put("sysRequest", "List Ping Servlets");
			params.put("sysClientId", p.assignedName);
			params.put("sysDebug", "True");
			params.put("sysReply", "True");
			params.put("sysTimeout", Integer.toString(10));

			try {
				sok = new SocketObj(p.enginePort, p.engineHostName);
				if (sok.connected)
				{
					sok.write(params);
					sok.read(params);
					sok.close();
				}
				else // (!sok.connected)
				{
					params.put("sysResultStatus", "-1");
					params.put("sysResultString", "Socket Connection failed");
				}

			} catch (ThrowableString e) {
				System.err.println("MonitorPoller::run() - " + e.getMessage());
			} catch (IOException ioe) {
				System.err.println("MonitorPoller::run() - No Engine Found " + ioe.getMessage());
			}

			if (params.containsKey("sysResultStatus") && params.get("sysResultStatus").equals("-1"))
			{
				System.err.println("MonitorPoller::run() - List Ping Servlets failed on attempt: " + 
					Integer.toString(attempts) + " with message: " + params.get("sysResultString"));
			}
			else failed = false;
		}
		if (failed) return -1;
		else return 0;
	}
}

