
//-----------------------------------------------------------
//
//	Softbolts Ltd. (c) all rights reserved
//
//	Warning: This  program is  protected by copyright law 
//		 and   international  treaties.  Unauthorised
//		 reproduction or distribution of this program,
//		 or  any portion  or it, may result in severe
//		 civil  and  criminal  penalties, and will be
//		 prosecuted to  the  maximum extent possible.
//
//              Author: A. E. Dawson, Aug 1999
//              mailto: anthony@softbolts.com
//
//		Last Revised: 3 July 2002
//
//-----------------------------------------------------------

package com.softbolts.nodes.TBNode;

import com.softbolts.lib.*;

import java.io.*;
import java.util.*;
import java.lang.*;
import java.lang.reflect.*;


public class ProcContainer extends Thread 
{
 Class[] argTypes = null;
 Object[] argList = null;
 Method mainMethod = null;
 String[] sArr = null;
 String classToRun = null;

        //-----------------------------------------------------------
        public ProcContainer(String classToRun, String wantedName) throws ThrowableString
        {
		this.classToRun = classToRun;
System.err.println("ProcContainer");
System.err.println("classToRun: " + classToRun);
System.err.println("wantedName: " + wantedName);
		int ndx = classToRun.lastIndexOf('.', classToRun.length());
		String procName = null;
		if (ndx > 0)
			procName = classToRun.substring(ndx + 1);
		else
			procName = classToRun;
System.err.println("USING procName: " + procName);
		try {
			argTypes = new Class[1];
			argTypes[0] = String[].class;
			mainMethod = Class.forName(classToRun).getDeclaredMethod("main", argTypes);
			sArr = new String[3];
			sArr[0] = new String(procName);
			sArr[1] = new String(wantedName);
			sArr[2] = new String("-noredirect");
			argList = new Object[1];
			argList[0] = sArr;
			//argList[0] = new String[1];
		} catch (ClassNotFoundException ex) {
			throw new ThrowableString("Class: " + classToRun + " not found in class path " + ex.getMessage());
		} catch (NoSuchMethodException ex) {
			throw new ThrowableString("Class: " + classToRun + " cannot find main class " + ex.getMessage());
		}
        }

        //-----------------------------------------------------------
        public void run()
        {
System.err.println("ProcContainer->run");
		try {
			mainMethod.invoke(null, argList);
		} catch (InvocationTargetException  ex) {
			System.err.println("ProcContainer() - Servlet " + classToRun + " InvocationTargetException: " + ex.getMessage());
			ex.printStackTrace();
		} catch (IllegalAccessException ex) {
			System.err.println("ProcContainer() - Servlet " + classToRun + " IllegalAccessException: " + ex.getMessage());
			ex.printStackTrace();
		} catch (NullPointerException ex) {
			System.err.println("ProcContainer() - Servlet " + classToRun + " NullPointerException: " + ex.getMessage());
			ex.printStackTrace();
		} catch (ExceptionInInitializerError ex) {
			System.err.println("ProcContainer() - Servlet " + classToRun + " ExceptionInInitializerError: " + ex.getMessage());
			ex.printStackTrace();
		} catch (IllegalArgumentException ex) {
			System.err.println("ProcContainer() - Servlet " + classToRun + " IllegalArgumentException: " + ex.getMessage());
			ex.printStackTrace();
		}
 	}
}

