
//-----------------------------------------------------------
//
//	Softbolts Ltd. (c) all rights reserved
//
//	Warning: This  program is  protected by copyright law 
//		 and   international  treaties.  Unauthorised
//		 reproduction or distribution of this program,
//		 or  any portion  or it, may result in severe
//		 civil  and  criminal  penalties, and will be
//		 prosecuted to  the  maximum extent possible.
//
//              Author: A. E. Dawson, Aug 1999
//              mailto: anthony@softbolts.com
//
//		Last Revised: 3 July 2002
//
//-----------------------------------------------------------

package com.softbolts.nodes.TBNode;

import com.softbolts.lib.*;

import java.io.*;
import java.util.*;
import java.lang.*;
import javax.xml.parsers.*;
import org.xml.sax.*;
import org.xml.sax.helpers.*;


//-----------------------------------------------------------
public class TBProcess extends ServletObj implements Serializable
{
 private Hashtable si  = null;		// maps servlet typeName to the ServletSpec class si = servlet info
 //private ServletEnv ne  = null;	// contains the node environment variables
 String tmpBuf = null;


	//-----------------------------------------------------------
	public TBProcess(BaseServlet p) //throws ThrowableString
	{
                try {
			si = ((XMLStreamHandler) p.handler).getServletSpec();

                } catch (Exception ex) {
                        ex.printStackTrace(System.err);
                        System.exit(0);
                }
	}

	//-----------------------------------------------------------
	public int init(NameValueTyp params) throws ThrowableString
	{
		System.out.println("---SERVLETS KNOWN TO THIS NODE CONTROLLER---");
		String key;
		ServletSpec value;
		Enumeration e = si.keys();
		while (e.hasMoreElements())
		{
			key = (String) e.nextElement();
			value = (ServletSpec) si.get(key);
			System.out.println("Servlet Type Name  -> " + key);
			System.out.println("Servlet Run Script -> " + value.script);
			System.out.println("Servlet Run Mode   -> " + value.runMode);
		}
		System.out.println("--------------FINISHED---------------------");

		return 0;
	}

	//-----------------------------------------------------------
	public int run(NameValueTyp params)
	{
	 String method = null;

		if((method = (String) params.get("sysMethod")) == null) return -1;
		if (method.equals("Get")) return Get(params);
		if (method.equals("Set")) return Set(params);
		if (method.equals("StartServlets")) return StartServletInstances(params);
		return 0;
	}

	//-----------------------------------------------------------
	public int Set(NameValueTyp params)
	{
		return 0;
	}

	//-----------------------------------------------------------
	public int Get(NameValueTyp params)
	{
		return 0;
	}

	//-----------------------------------------------------------
	public int StartServletInstances(NameValueTyp params)
	{
         String ndx = null, typeName = null;
	 StringTokenizer strTok = null;

		System.err.println("StartServletInstances called");
		params.put("sysResultString", "");
		for (int i = 0; (ndx = new String("sysServletInstance" + Integer.toString(i))) != null && 
			params.containsKey(ndx); i++)
		{
			System.err.println("Starting: " + (String) params.get(ndx));
			strTok = new StringTokenizer((String) params.get(ndx), "_", false);
			typeName = strTok.nextToken();
			if (!si.containsKey(typeName))
			{
				params.put("sysResultStatus", "-1");
				tmpBuf = (String) params.get("sysResultString");
				String errMsg = "StartServletInstances() - unknown servlet type: " + params.get(ndx) + "\n";
				System.err.println("ERR: Node controller - " + errMsg);
				params.put("sysResultString", tmpBuf + errMsg);
				continue;
			}
			try {
				StartServlet(typeName, (String) params.get(ndx));
			} catch (ThrowableString s) {
				params.put("sysResultStatus", "-1");
				System.err.println("ERR: Node controller - " + s);
				params.put("sysResultString", ((String) params.get("sysResultString")) + s);
			}
		}
		StartServletTypes(params);

		return 0;
	}

	//-----------------------------------------------------------
	public int StartServletTypes(NameValueTyp params)
	{
         String ndx = null, typeName = null;

		System.err.println("StartServletTypes called");
		params.put("sysResultString", "");
PersistStream.printMap(params);
		for (int i = 0; (ndx = new String("sysStartServletType" + Integer.toString(i))) != null && 
			params.containsKey(ndx); i++)
		{
			typeName = (String) params.get(ndx);
			if (!si.containsKey(typeName))
			{
				params.put("sysResultStatus", "-1");
				tmpBuf = (String) params.get("sysResultString");
				String errMsg = "StartServletTypes() - unknown servlet type: " + params.get(ndx) + "\n";
				System.err.println("ERR: Node controller - " + errMsg);
				params.put("sysResultString", tmpBuf + errMsg);
				continue;
			}
System.err.println("typeName: " + typeName);
			try {
				StartServlet(typeName, "");
			} catch (ThrowableString s) {
				params.put("sysResultStatus", "-1");
				System.err.println("ERR: Node controller - " + s);
				params.put("sysResultString", ((String) params.get("sysResultString")) + s);
			}
		}
System.err.println("FINISHED");
		return 0;
	}

	//-----------------------------------------------------------
	public void StartServlet(String typeName, String wantedName) throws ThrowableString
	{
	 ServletSpec s = (ServletSpec) si.get(typeName);

System.err.println("StartServlet() - typeName   >" + typeName + "<");
System.err.println("StartServlet() - wantedName >" + wantedName + "<");
		if (s.runMode.equals("script"))
		{
			runByScript(s.script, wantedName);
		}
		else if (s.runMode.equals("java_container"))
		{
			runInContainer(s.script, wantedName);
		}
		else if (s.runMode.equals("jvm"))
			throw new ThrowableString("runMode: jvm not yet implemented for servlet type: " + typeName + "\n");
		else
			throw new ThrowableString("Unknown runMode: " + s.runMode + " for servlet type: " + typeName + "\n");
	}

	//-----------------------------------------------------------
	public void runInContainer(String script, String wantedName)
	{
System.err.println("Run in container");
		try {   // runs a java program on the same JVM
			ProcContainer runner = new ProcContainer(script, wantedName);
			runner.start();
		} catch (ThrowableString s) {
			System.err.println(s.getMessage());
		}
	}

	//-----------------------------------------------------------
	public int runByScript(String scriptName, String wantedName)
	{
	 String cmd = null;
	 String osName = System.getProperty("os.name" );

System.err.println("Run by script");
		System.err.println("osName: " + osName);
		try
		{            
			if (osName != null)
			{
				if(osName.equals( "Windows 2000" ) ||
					osName.equals( "Windows NT" ) || 
					osName.equals( "Windows XP"))
				{
					cmd = "cmd.exe /C " + scriptName + " " + wantedName;
					System.err.println("Running command: " + cmd +" on OS " + osName);
				}
				else if( osName.equals( "Windows 95" ) )
				{
					cmd = "command.com /C " + scriptName + " " + wantedName;
					System.err.println("Running command: " + cmd +" on OS " + osName);
				}
				else if(osName.equals("Linux"))
				{
					cmd = scriptName + " " + wantedName;
					System.err.println("Running command: " + cmd +" on OS " + osName);
				}
			} 
			else	// try just the command!
			{
				cmd = scriptName + " " + wantedName;
			}
									// if in windows do this as a separate daemon thread 
									// or it will work only once!
/*
			if(osName.equals( "Windows 2000" ) ||
				osName.equals( "Windows NT" ) || 
				osName.equals( "Windows XP"))
			{
			}
			else if(osName.equals("Linux"))
			{
*/
				Runtime rt = Runtime.getRuntime();
				System.err.println("Trying to run >>>>>>>>>>>>>>>> " + cmd); 
				Process proc = rt.exec(cmd);
				// any error message?
				StreamSync errorSync = new StreamSync(proc.getErrorStream(), "ERROR");            

				// any output?
				StreamSync outputSync = new StreamSync(proc.getInputStream(), "OUTPUT");

				// kick them off
				errorSync.start();
				outputSync.start();
				    
				// any error???
				int exitVal = proc.waitFor();
				System.err.println("ExitValue: " + exitVal);        
//			}
		} catch (Throwable t) {
			t.printStackTrace();
			return -1;
		}
		return 0;
	}
}

